<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfApisInformation ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfApisInformation
 * @subpackage Arrays
 */
class ArrayOfApisInformation extends AbstractStructArrayBase
{
    /**
     * The ApisInformation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ApisInformation[]
     */
    public $ApisInformation;
    /**
     * Constructor method for ArrayOfApisInformation
     * @uses ArrayOfApisInformation::setApisInformation()
     * @param \StructType\ApisInformation[] $apisInformation
     */
    public function __construct(array $apisInformation = array())
    {
        $this
            ->setApisInformation($apisInformation);
    }
    /**
     * Get ApisInformation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ApisInformation[]|null
     */
    public function getApisInformation()
    {
        return isset($this->ApisInformation) ? $this->ApisInformation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setApisInformation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setApisInformation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateApisInformationForArrayConstraintsFromSetApisInformation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfApisInformationApisInformationItem) {
            // validation for constraint: itemType
            if (!$arrayOfApisInformationApisInformationItem instanceof \StructType\ApisInformation) {
                $invalidValues[] = is_object($arrayOfApisInformationApisInformationItem) ? get_class($arrayOfApisInformationApisInformationItem) : sprintf('%s(%s)', gettype($arrayOfApisInformationApisInformationItem), var_export($arrayOfApisInformationApisInformationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ApisInformation property can only contain items of type \StructType\ApisInformation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ApisInformation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ApisInformation[] $apisInformation
     * @return \ArrayType\ArrayOfApisInformation
     */
    public function setApisInformation(array $apisInformation = array())
    {
        // validation for constraint: array
        if ('' !== ($apisInformationArrayErrorMessage = self::validateApisInformationForArrayConstraintsFromSetApisInformation($apisInformation))) {
            throw new \InvalidArgumentException($apisInformationArrayErrorMessage, __LINE__);
        }
        if (is_null($apisInformation) || (is_array($apisInformation) && empty($apisInformation))) {
            unset($this->ApisInformation);
        } else {
            $this->ApisInformation = $apisInformation;
        }
        return $this;
    }
    /**
     * Add item to ApisInformation value
     * @throws \InvalidArgumentException
     * @param \StructType\ApisInformation $item
     * @return \ArrayType\ArrayOfApisInformation
     */
    public function addToApisInformation(\StructType\ApisInformation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ApisInformation) {
            throw new \InvalidArgumentException(sprintf('The ApisInformation property can only contain items of type \StructType\ApisInformation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ApisInformation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ApisInformation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ApisInformation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ApisInformation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ApisInformation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ApisInformation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ApisInformation
     */
    public function getAttributeName()
    {
        return 'ApisInformation';
    }
}
