<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfImportPNR.Reservation.Comment ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfImportPNR.Reservation.Comment
 * @subpackage Arrays
 */
class ArrayOfImportPNR_Reservation_Comment extends AbstractStructArrayBase
{
    /**
     * The ImportPNR_Reservation_Comment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ImportPNR_Reservation_Comment[]
     */
    public $ImportPNR_Reservation_Comment;
    /**
     * Constructor method for ArrayOfImportPNR.Reservation.Comment
     * @uses ArrayOfImportPNR_Reservation_Comment::setImportPNR_Reservation_Comment()
     * @param \StructType\ImportPNR_Reservation_Comment[] $importPNR_Reservation_Comment
     */
    public function __construct(array $importPNR_Reservation_Comment = array())
    {
        $this
            ->setImportPNR_Reservation_Comment($importPNR_Reservation_Comment);
    }
    /**
     * Get ImportPNR_Reservation_Comment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ImportPNR_Reservation_Comment[]|null
     */
    public function getImportPNR_Reservation_Comment()
    {
        return isset($this->{'ImportPNR.Reservation.Comment'}) ? $this->{'ImportPNR.Reservation.Comment'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setImportPNR_Reservation_Comment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setImportPNR_Reservation_Comment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateImportPNR_Reservation_CommentForArrayConstraintsFromSetImportPNR_Reservation_Comment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfImportPNR_Reservation_CommentImportPNR_Reservation_CommentItem) {
            // validation for constraint: itemType
            if (!$arrayOfImportPNR_Reservation_CommentImportPNR_Reservation_CommentItem instanceof \StructType\ImportPNR_Reservation_Comment) {
                $invalidValues[] = is_object($arrayOfImportPNR_Reservation_CommentImportPNR_Reservation_CommentItem) ? get_class($arrayOfImportPNR_Reservation_CommentImportPNR_Reservation_CommentItem) : sprintf('%s(%s)', gettype($arrayOfImportPNR_Reservation_CommentImportPNR_Reservation_CommentItem), var_export($arrayOfImportPNR_Reservation_CommentImportPNR_Reservation_CommentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ImportPNR_Reservation_Comment property can only contain items of type \StructType\ImportPNR_Reservation_Comment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ImportPNR_Reservation_Comment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ImportPNR_Reservation_Comment[] $importPNR_Reservation_Comment
     * @return \ArrayType\ArrayOfImportPNR_Reservation_Comment
     */
    public function setImportPNR_Reservation_Comment(array $importPNR_Reservation_Comment = array())
    {
        // validation for constraint: array
        if ('' !== ($importPNR_Reservation_CommentArrayErrorMessage = self::validateImportPNR_Reservation_CommentForArrayConstraintsFromSetImportPNR_Reservation_Comment($importPNR_Reservation_Comment))) {
            throw new \InvalidArgumentException($importPNR_Reservation_CommentArrayErrorMessage, __LINE__);
        }
        if (is_null($importPNR_Reservation_Comment) || (is_array($importPNR_Reservation_Comment) && empty($importPNR_Reservation_Comment))) {
            unset($this->ImportPNR_Reservation_Comment, $this->{'ImportPNR.Reservation.Comment'});
        } else {
            $this->ImportPNR_Reservation_Comment = $this->{'ImportPNR.Reservation.Comment'} = $importPNR_Reservation_Comment;
        }
        return $this;
    }
    /**
     * Add item to ImportPNR_Reservation_Comment value
     * @throws \InvalidArgumentException
     * @param \StructType\ImportPNR_Reservation_Comment $item
     * @return \ArrayType\ArrayOfImportPNR_Reservation_Comment
     */
    public function addToImportPNR_Reservation_Comment(\StructType\ImportPNR_Reservation_Comment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ImportPNR_Reservation_Comment) {
            throw new \InvalidArgumentException(sprintf('The ImportPNR_Reservation_Comment property can only contain items of type \StructType\ImportPNR_Reservation_Comment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ImportPNR_Reservation_Comment[] = $this->{'ImportPNR.Reservation.Comment'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ImportPNR_Reservation_Comment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ImportPNR_Reservation_Comment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ImportPNR_Reservation_Comment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ImportPNR_Reservation_Comment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ImportPNR_Reservation_Comment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ImportPNR.Reservation.Comment
     */
    public function getAttributeName()
    {
        return 'ImportPNR.Reservation.Comment';
    }
}
