<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfImportPNR.Reservation.Person ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfImportPNR.Reservation.Person
 * @subpackage Arrays
 */
class ArrayOfImportPNR_Reservation_Person extends AbstractStructArrayBase
{
    /**
     * The ImportPNR_Reservation_Person
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ImportPNR_Reservation_Person[]
     */
    public $ImportPNR_Reservation_Person;
    /**
     * Constructor method for ArrayOfImportPNR.Reservation.Person
     * @uses ArrayOfImportPNR_Reservation_Person::setImportPNR_Reservation_Person()
     * @param \StructType\ImportPNR_Reservation_Person[] $importPNR_Reservation_Person
     */
    public function __construct(array $importPNR_Reservation_Person = array())
    {
        $this
            ->setImportPNR_Reservation_Person($importPNR_Reservation_Person);
    }
    /**
     * Get ImportPNR_Reservation_Person value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ImportPNR_Reservation_Person[]|null
     */
    public function getImportPNR_Reservation_Person()
    {
        return isset($this->{'ImportPNR.Reservation.Person'}) ? $this->{'ImportPNR.Reservation.Person'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setImportPNR_Reservation_Person method
     * This method is willingly generated in order to preserve the one-line inline validation within the setImportPNR_Reservation_Person method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateImportPNR_Reservation_PersonForArrayConstraintsFromSetImportPNR_Reservation_Person(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfImportPNR_Reservation_PersonImportPNR_Reservation_PersonItem) {
            // validation for constraint: itemType
            if (!$arrayOfImportPNR_Reservation_PersonImportPNR_Reservation_PersonItem instanceof \StructType\ImportPNR_Reservation_Person) {
                $invalidValues[] = is_object($arrayOfImportPNR_Reservation_PersonImportPNR_Reservation_PersonItem) ? get_class($arrayOfImportPNR_Reservation_PersonImportPNR_Reservation_PersonItem) : sprintf('%s(%s)', gettype($arrayOfImportPNR_Reservation_PersonImportPNR_Reservation_PersonItem), var_export($arrayOfImportPNR_Reservation_PersonImportPNR_Reservation_PersonItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ImportPNR_Reservation_Person property can only contain items of type \StructType\ImportPNR_Reservation_Person, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ImportPNR_Reservation_Person value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ImportPNR_Reservation_Person[] $importPNR_Reservation_Person
     * @return \ArrayType\ArrayOfImportPNR_Reservation_Person
     */
    public function setImportPNR_Reservation_Person(array $importPNR_Reservation_Person = array())
    {
        // validation for constraint: array
        if ('' !== ($importPNR_Reservation_PersonArrayErrorMessage = self::validateImportPNR_Reservation_PersonForArrayConstraintsFromSetImportPNR_Reservation_Person($importPNR_Reservation_Person))) {
            throw new \InvalidArgumentException($importPNR_Reservation_PersonArrayErrorMessage, __LINE__);
        }
        if (is_null($importPNR_Reservation_Person) || (is_array($importPNR_Reservation_Person) && empty($importPNR_Reservation_Person))) {
            unset($this->ImportPNR_Reservation_Person, $this->{'ImportPNR.Reservation.Person'});
        } else {
            $this->ImportPNR_Reservation_Person = $this->{'ImportPNR.Reservation.Person'} = $importPNR_Reservation_Person;
        }
        return $this;
    }
    /**
     * Add item to ImportPNR_Reservation_Person value
     * @throws \InvalidArgumentException
     * @param \StructType\ImportPNR_Reservation_Person $item
     * @return \ArrayType\ArrayOfImportPNR_Reservation_Person
     */
    public function addToImportPNR_Reservation_Person(\StructType\ImportPNR_Reservation_Person $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ImportPNR_Reservation_Person) {
            throw new \InvalidArgumentException(sprintf('The ImportPNR_Reservation_Person property can only contain items of type \StructType\ImportPNR_Reservation_Person, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ImportPNR_Reservation_Person[] = $this->{'ImportPNR.Reservation.Person'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ImportPNR_Reservation_Person|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ImportPNR_Reservation_Person|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ImportPNR_Reservation_Person|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ImportPNR_Reservation_Person|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ImportPNR_Reservation_Person|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ImportPNR.Reservation.Person
     */
    public function getAttributeName()
    {
        return 'ImportPNR.Reservation.Person';
    }
}
