<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfImportPNR.Reservation.Segment ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfImportPNR.Reservation.Segment
 * @subpackage Arrays
 */
class ArrayOfImportPNR_Reservation_Segment extends AbstractStructArrayBase
{
    /**
     * The ImportPNR_Reservation_Segment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ImportPNR_Reservation_Segment[]
     */
    public $ImportPNR_Reservation_Segment;
    /**
     * Constructor method for ArrayOfImportPNR.Reservation.Segment
     * @uses ArrayOfImportPNR_Reservation_Segment::setImportPNR_Reservation_Segment()
     * @param \StructType\ImportPNR_Reservation_Segment[] $importPNR_Reservation_Segment
     */
    public function __construct(array $importPNR_Reservation_Segment = array())
    {
        $this
            ->setImportPNR_Reservation_Segment($importPNR_Reservation_Segment);
    }
    /**
     * Get ImportPNR_Reservation_Segment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ImportPNR_Reservation_Segment[]|null
     */
    public function getImportPNR_Reservation_Segment()
    {
        return isset($this->{'ImportPNR.Reservation.Segment'}) ? $this->{'ImportPNR.Reservation.Segment'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setImportPNR_Reservation_Segment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setImportPNR_Reservation_Segment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateImportPNR_Reservation_SegmentForArrayConstraintsFromSetImportPNR_Reservation_Segment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfImportPNR_Reservation_SegmentImportPNR_Reservation_SegmentItem) {
            // validation for constraint: itemType
            if (!$arrayOfImportPNR_Reservation_SegmentImportPNR_Reservation_SegmentItem instanceof \StructType\ImportPNR_Reservation_Segment) {
                $invalidValues[] = is_object($arrayOfImportPNR_Reservation_SegmentImportPNR_Reservation_SegmentItem) ? get_class($arrayOfImportPNR_Reservation_SegmentImportPNR_Reservation_SegmentItem) : sprintf('%s(%s)', gettype($arrayOfImportPNR_Reservation_SegmentImportPNR_Reservation_SegmentItem), var_export($arrayOfImportPNR_Reservation_SegmentImportPNR_Reservation_SegmentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ImportPNR_Reservation_Segment property can only contain items of type \StructType\ImportPNR_Reservation_Segment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ImportPNR_Reservation_Segment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ImportPNR_Reservation_Segment[] $importPNR_Reservation_Segment
     * @return \ArrayType\ArrayOfImportPNR_Reservation_Segment
     */
    public function setImportPNR_Reservation_Segment(array $importPNR_Reservation_Segment = array())
    {
        // validation for constraint: array
        if ('' !== ($importPNR_Reservation_SegmentArrayErrorMessage = self::validateImportPNR_Reservation_SegmentForArrayConstraintsFromSetImportPNR_Reservation_Segment($importPNR_Reservation_Segment))) {
            throw new \InvalidArgumentException($importPNR_Reservation_SegmentArrayErrorMessage, __LINE__);
        }
        if (is_null($importPNR_Reservation_Segment) || (is_array($importPNR_Reservation_Segment) && empty($importPNR_Reservation_Segment))) {
            unset($this->ImportPNR_Reservation_Segment, $this->{'ImportPNR.Reservation.Segment'});
        } else {
            $this->ImportPNR_Reservation_Segment = $this->{'ImportPNR.Reservation.Segment'} = $importPNR_Reservation_Segment;
        }
        return $this;
    }
    /**
     * Add item to ImportPNR_Reservation_Segment value
     * @throws \InvalidArgumentException
     * @param \StructType\ImportPNR_Reservation_Segment $item
     * @return \ArrayType\ArrayOfImportPNR_Reservation_Segment
     */
    public function addToImportPNR_Reservation_Segment(\StructType\ImportPNR_Reservation_Segment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ImportPNR_Reservation_Segment) {
            throw new \InvalidArgumentException(sprintf('The ImportPNR_Reservation_Segment property can only contain items of type \StructType\ImportPNR_Reservation_Segment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ImportPNR_Reservation_Segment[] = $this->{'ImportPNR.Reservation.Segment'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ImportPNR_Reservation_Segment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ImportPNR_Reservation_Segment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ImportPNR_Reservation_Segment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ImportPNR_Reservation_Segment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ImportPNR_Reservation_Segment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ImportPNR.Reservation.Segment
     */
    public function getAttributeName()
    {
        return 'ImportPNR.Reservation.Segment';
    }
}
