<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfModifyPNR.FlightInformation ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfModifyPNR.FlightInformation
 * @subpackage Arrays
 */
class ArrayOfModifyPNR_FlightInformation extends AbstractStructArrayBase
{
    /**
     * The ModifyPNR_FlightInformation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ModifyPNR_FlightInformation[]
     */
    public $ModifyPNR_FlightInformation;
    /**
     * Constructor method for ArrayOfModifyPNR.FlightInformation
     * @uses ArrayOfModifyPNR_FlightInformation::setModifyPNR_FlightInformation()
     * @param \StructType\ModifyPNR_FlightInformation[] $modifyPNR_FlightInformation
     */
    public function __construct(array $modifyPNR_FlightInformation = array())
    {
        $this
            ->setModifyPNR_FlightInformation($modifyPNR_FlightInformation);
    }
    /**
     * Get ModifyPNR_FlightInformation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ModifyPNR_FlightInformation[]|null
     */
    public function getModifyPNR_FlightInformation()
    {
        return isset($this->{'ModifyPNR.FlightInformation'}) ? $this->{'ModifyPNR.FlightInformation'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setModifyPNR_FlightInformation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setModifyPNR_FlightInformation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateModifyPNR_FlightInformationForArrayConstraintsFromSetModifyPNR_FlightInformation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfModifyPNR_FlightInformationModifyPNR_FlightInformationItem) {
            // validation for constraint: itemType
            if (!$arrayOfModifyPNR_FlightInformationModifyPNR_FlightInformationItem instanceof \StructType\ModifyPNR_FlightInformation) {
                $invalidValues[] = is_object($arrayOfModifyPNR_FlightInformationModifyPNR_FlightInformationItem) ? get_class($arrayOfModifyPNR_FlightInformationModifyPNR_FlightInformationItem) : sprintf('%s(%s)', gettype($arrayOfModifyPNR_FlightInformationModifyPNR_FlightInformationItem), var_export($arrayOfModifyPNR_FlightInformationModifyPNR_FlightInformationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ModifyPNR_FlightInformation property can only contain items of type \StructType\ModifyPNR_FlightInformation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ModifyPNR_FlightInformation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ModifyPNR_FlightInformation[] $modifyPNR_FlightInformation
     * @return \ArrayType\ArrayOfModifyPNR_FlightInformation
     */
    public function setModifyPNR_FlightInformation(array $modifyPNR_FlightInformation = array())
    {
        // validation for constraint: array
        if ('' !== ($modifyPNR_FlightInformationArrayErrorMessage = self::validateModifyPNR_FlightInformationForArrayConstraintsFromSetModifyPNR_FlightInformation($modifyPNR_FlightInformation))) {
            throw new \InvalidArgumentException($modifyPNR_FlightInformationArrayErrorMessage, __LINE__);
        }
        if (is_null($modifyPNR_FlightInformation) || (is_array($modifyPNR_FlightInformation) && empty($modifyPNR_FlightInformation))) {
            unset($this->ModifyPNR_FlightInformation, $this->{'ModifyPNR.FlightInformation'});
        } else {
            $this->ModifyPNR_FlightInformation = $this->{'ModifyPNR.FlightInformation'} = $modifyPNR_FlightInformation;
        }
        return $this;
    }
    /**
     * Add item to ModifyPNR_FlightInformation value
     * @throws \InvalidArgumentException
     * @param \StructType\ModifyPNR_FlightInformation $item
     * @return \ArrayType\ArrayOfModifyPNR_FlightInformation
     */
    public function addToModifyPNR_FlightInformation(\StructType\ModifyPNR_FlightInformation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ModifyPNR_FlightInformation) {
            throw new \InvalidArgumentException(sprintf('The ModifyPNR_FlightInformation property can only contain items of type \StructType\ModifyPNR_FlightInformation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ModifyPNR_FlightInformation[] = $this->{'ModifyPNR.FlightInformation'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ModifyPNR_FlightInformation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ModifyPNR_FlightInformation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ModifyPNR_FlightInformation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ModifyPNR_FlightInformation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ModifyPNR_FlightInformation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ModifyPNR.FlightInformation
     */
    public function getAttributeName()
    {
        return 'ModifyPNR.FlightInformation';
    }
}
