<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOALAirlinePerson ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOALAirlinePerson
 * @subpackage Arrays
 */
class ArrayOfOALAirlinePerson extends AbstractStructArrayBase
{
    /**
     * The OALAirlinePerson
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OALAirlinePerson[]
     */
    public $OALAirlinePerson;
    /**
     * Constructor method for ArrayOfOALAirlinePerson
     * @uses ArrayOfOALAirlinePerson::setOALAirlinePerson()
     * @param \StructType\OALAirlinePerson[] $oALAirlinePerson
     */
    public function __construct(array $oALAirlinePerson = array())
    {
        $this
            ->setOALAirlinePerson($oALAirlinePerson);
    }
    /**
     * Get OALAirlinePerson value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OALAirlinePerson[]|null
     */
    public function getOALAirlinePerson()
    {
        return isset($this->OALAirlinePerson) ? $this->OALAirlinePerson : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOALAirlinePerson method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOALAirlinePerson method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOALAirlinePersonForArrayConstraintsFromSetOALAirlinePerson(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOALAirlinePersonOALAirlinePersonItem) {
            // validation for constraint: itemType
            if (!$arrayOfOALAirlinePersonOALAirlinePersonItem instanceof \StructType\OALAirlinePerson) {
                $invalidValues[] = is_object($arrayOfOALAirlinePersonOALAirlinePersonItem) ? get_class($arrayOfOALAirlinePersonOALAirlinePersonItem) : sprintf('%s(%s)', gettype($arrayOfOALAirlinePersonOALAirlinePersonItem), var_export($arrayOfOALAirlinePersonOALAirlinePersonItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OALAirlinePerson property can only contain items of type \StructType\OALAirlinePerson, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OALAirlinePerson value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OALAirlinePerson[] $oALAirlinePerson
     * @return \ArrayType\ArrayOfOALAirlinePerson
     */
    public function setOALAirlinePerson(array $oALAirlinePerson = array())
    {
        // validation for constraint: array
        if ('' !== ($oALAirlinePersonArrayErrorMessage = self::validateOALAirlinePersonForArrayConstraintsFromSetOALAirlinePerson($oALAirlinePerson))) {
            throw new \InvalidArgumentException($oALAirlinePersonArrayErrorMessage, __LINE__);
        }
        if (is_null($oALAirlinePerson) || (is_array($oALAirlinePerson) && empty($oALAirlinePerson))) {
            unset($this->OALAirlinePerson);
        } else {
            $this->OALAirlinePerson = $oALAirlinePerson;
        }
        return $this;
    }
    /**
     * Add item to OALAirlinePerson value
     * @throws \InvalidArgumentException
     * @param \StructType\OALAirlinePerson $item
     * @return \ArrayType\ArrayOfOALAirlinePerson
     */
    public function addToOALAirlinePerson(\StructType\OALAirlinePerson $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OALAirlinePerson) {
            throw new \InvalidArgumentException(sprintf('The OALAirlinePerson property can only contain items of type \StructType\OALAirlinePerson, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OALAirlinePerson[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OALAirlinePerson|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OALAirlinePerson|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OALAirlinePerson|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OALAirlinePerson|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OALAirlinePerson|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OALAirlinePerson
     */
    public function getAttributeName()
    {
        return 'OALAirlinePerson';
    }
}
