<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOALSegment ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOALSegment
 * @subpackage Arrays
 */
class ArrayOfOALSegment extends AbstractStructArrayBase
{
    /**
     * The OALSegment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OALSegment[]
     */
    public $OALSegment;
    /**
     * Constructor method for ArrayOfOALSegment
     * @uses ArrayOfOALSegment::setOALSegment()
     * @param \StructType\OALSegment[] $oALSegment
     */
    public function __construct(array $oALSegment = array())
    {
        $this
            ->setOALSegment($oALSegment);
    }
    /**
     * Get OALSegment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OALSegment[]|null
     */
    public function getOALSegment()
    {
        return isset($this->OALSegment) ? $this->OALSegment : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOALSegment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOALSegment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOALSegmentForArrayConstraintsFromSetOALSegment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOALSegmentOALSegmentItem) {
            // validation for constraint: itemType
            if (!$arrayOfOALSegmentOALSegmentItem instanceof \StructType\OALSegment) {
                $invalidValues[] = is_object($arrayOfOALSegmentOALSegmentItem) ? get_class($arrayOfOALSegmentOALSegmentItem) : sprintf('%s(%s)', gettype($arrayOfOALSegmentOALSegmentItem), var_export($arrayOfOALSegmentOALSegmentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OALSegment property can only contain items of type \StructType\OALSegment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OALSegment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OALSegment[] $oALSegment
     * @return \ArrayType\ArrayOfOALSegment
     */
    public function setOALSegment(array $oALSegment = array())
    {
        // validation for constraint: array
        if ('' !== ($oALSegmentArrayErrorMessage = self::validateOALSegmentForArrayConstraintsFromSetOALSegment($oALSegment))) {
            throw new \InvalidArgumentException($oALSegmentArrayErrorMessage, __LINE__);
        }
        if (is_null($oALSegment) || (is_array($oALSegment) && empty($oALSegment))) {
            unset($this->OALSegment);
        } else {
            $this->OALSegment = $oALSegment;
        }
        return $this;
    }
    /**
     * Add item to OALSegment value
     * @throws \InvalidArgumentException
     * @param \StructType\OALSegment $item
     * @return \ArrayType\ArrayOfOALSegment
     */
    public function addToOALSegment(\StructType\OALSegment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OALSegment) {
            throw new \InvalidArgumentException(sprintf('The OALSegment property can only contain items of type \StructType\OALSegment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OALSegment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OALSegment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OALSegment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OALSegment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OALSegment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OALSegment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OALSegment
     */
    public function getAttributeName()
    {
        return 'OALSegment';
    }
}
