<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOverrideChargeDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOverrideChargeDetail
 * @subpackage Arrays
 */
class ArrayOfOverrideChargeDetail extends AbstractStructArrayBase
{
    /**
     * The OverrideChargeDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OverrideChargeDetail[]
     */
    public $OverrideChargeDetail;
    /**
     * Constructor method for ArrayOfOverrideChargeDetail
     * @uses ArrayOfOverrideChargeDetail::setOverrideChargeDetail()
     * @param \StructType\OverrideChargeDetail[] $overrideChargeDetail
     */
    public function __construct(array $overrideChargeDetail = array())
    {
        $this
            ->setOverrideChargeDetail($overrideChargeDetail);
    }
    /**
     * Get OverrideChargeDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OverrideChargeDetail[]|null
     */
    public function getOverrideChargeDetail()
    {
        return isset($this->OverrideChargeDetail) ? $this->OverrideChargeDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOverrideChargeDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOverrideChargeDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOverrideChargeDetailForArrayConstraintsFromSetOverrideChargeDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOverrideChargeDetailOverrideChargeDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfOverrideChargeDetailOverrideChargeDetailItem instanceof \StructType\OverrideChargeDetail) {
                $invalidValues[] = is_object($arrayOfOverrideChargeDetailOverrideChargeDetailItem) ? get_class($arrayOfOverrideChargeDetailOverrideChargeDetailItem) : sprintf('%s(%s)', gettype($arrayOfOverrideChargeDetailOverrideChargeDetailItem), var_export($arrayOfOverrideChargeDetailOverrideChargeDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OverrideChargeDetail property can only contain items of type \StructType\OverrideChargeDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OverrideChargeDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OverrideChargeDetail[] $overrideChargeDetail
     * @return \ArrayType\ArrayOfOverrideChargeDetail
     */
    public function setOverrideChargeDetail(array $overrideChargeDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($overrideChargeDetailArrayErrorMessage = self::validateOverrideChargeDetailForArrayConstraintsFromSetOverrideChargeDetail($overrideChargeDetail))) {
            throw new \InvalidArgumentException($overrideChargeDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($overrideChargeDetail) || (is_array($overrideChargeDetail) && empty($overrideChargeDetail))) {
            unset($this->OverrideChargeDetail);
        } else {
            $this->OverrideChargeDetail = $overrideChargeDetail;
        }
        return $this;
    }
    /**
     * Add item to OverrideChargeDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\OverrideChargeDetail $item
     * @return \ArrayType\ArrayOfOverrideChargeDetail
     */
    public function addToOverrideChargeDetail(\StructType\OverrideChargeDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OverrideChargeDetail) {
            throw new \InvalidArgumentException(sprintf('The OverrideChargeDetail property can only contain items of type \StructType\OverrideChargeDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OverrideChargeDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OverrideChargeDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OverrideChargeDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OverrideChargeDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OverrideChargeDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OverrideChargeDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OverrideChargeDetail
     */
    public function getAttributeName()
    {
        return 'OverrideChargeDetail';
    }
}
