<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRefundChargeDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRefundChargeDetail
 * @subpackage Arrays
 */
class ArrayOfRefundChargeDetail extends AbstractStructArrayBase
{
    /**
     * The RefundChargeDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RefundChargeDetail[]
     */
    public $RefundChargeDetail;
    /**
     * Constructor method for ArrayOfRefundChargeDetail
     * @uses ArrayOfRefundChargeDetail::setRefundChargeDetail()
     * @param \StructType\RefundChargeDetail[] $refundChargeDetail
     */
    public function __construct(array $refundChargeDetail = array())
    {
        $this
            ->setRefundChargeDetail($refundChargeDetail);
    }
    /**
     * Get RefundChargeDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RefundChargeDetail[]|null
     */
    public function getRefundChargeDetail()
    {
        return isset($this->RefundChargeDetail) ? $this->RefundChargeDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRefundChargeDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRefundChargeDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRefundChargeDetailForArrayConstraintsFromSetRefundChargeDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRefundChargeDetailRefundChargeDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfRefundChargeDetailRefundChargeDetailItem instanceof \StructType\RefundChargeDetail) {
                $invalidValues[] = is_object($arrayOfRefundChargeDetailRefundChargeDetailItem) ? get_class($arrayOfRefundChargeDetailRefundChargeDetailItem) : sprintf('%s(%s)', gettype($arrayOfRefundChargeDetailRefundChargeDetailItem), var_export($arrayOfRefundChargeDetailRefundChargeDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RefundChargeDetail property can only contain items of type \StructType\RefundChargeDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RefundChargeDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RefundChargeDetail[] $refundChargeDetail
     * @return \ArrayType\ArrayOfRefundChargeDetail
     */
    public function setRefundChargeDetail(array $refundChargeDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($refundChargeDetailArrayErrorMessage = self::validateRefundChargeDetailForArrayConstraintsFromSetRefundChargeDetail($refundChargeDetail))) {
            throw new \InvalidArgumentException($refundChargeDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($refundChargeDetail) || (is_array($refundChargeDetail) && empty($refundChargeDetail))) {
            unset($this->RefundChargeDetail);
        } else {
            $this->RefundChargeDetail = $refundChargeDetail;
        }
        return $this;
    }
    /**
     * Add item to RefundChargeDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\RefundChargeDetail $item
     * @return \ArrayType\ArrayOfRefundChargeDetail
     */
    public function addToRefundChargeDetail(\StructType\RefundChargeDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RefundChargeDetail) {
            throw new \InvalidArgumentException(sprintf('The RefundChargeDetail property can only contain items of type \StructType\RefundChargeDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RefundChargeDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RefundChargeDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RefundChargeDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RefundChargeDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RefundChargeDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RefundChargeDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RefundChargeDetail
     */
    public function getAttributeName()
    {
        return 'RefundChargeDetail';
    }
}
