<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfReservationByNationalId ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfReservationByNationalId
 * @subpackage Arrays
 */
class ArrayOfReservationByNationalId extends AbstractStructArrayBase
{
    /**
     * The ReservationByNationalId
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ReservationByNationalId[]
     */
    public $ReservationByNationalId;
    /**
     * Constructor method for ArrayOfReservationByNationalId
     * @uses ArrayOfReservationByNationalId::setReservationByNationalId()
     * @param \StructType\ReservationByNationalId[] $reservationByNationalId
     */
    public function __construct(array $reservationByNationalId = array())
    {
        $this
            ->setReservationByNationalId($reservationByNationalId);
    }
    /**
     * Get ReservationByNationalId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ReservationByNationalId[]|null
     */
    public function getReservationByNationalId()
    {
        return isset($this->ReservationByNationalId) ? $this->ReservationByNationalId : null;
    }
    /**
     * This method is responsible for validating the values passed to the setReservationByNationalId method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReservationByNationalId method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReservationByNationalIdForArrayConstraintsFromSetReservationByNationalId(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfReservationByNationalIdReservationByNationalIdItem) {
            // validation for constraint: itemType
            if (!$arrayOfReservationByNationalIdReservationByNationalIdItem instanceof \StructType\ReservationByNationalId) {
                $invalidValues[] = is_object($arrayOfReservationByNationalIdReservationByNationalIdItem) ? get_class($arrayOfReservationByNationalIdReservationByNationalIdItem) : sprintf('%s(%s)', gettype($arrayOfReservationByNationalIdReservationByNationalIdItem), var_export($arrayOfReservationByNationalIdReservationByNationalIdItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReservationByNationalId property can only contain items of type \StructType\ReservationByNationalId, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReservationByNationalId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ReservationByNationalId[] $reservationByNationalId
     * @return \ArrayType\ArrayOfReservationByNationalId
     */
    public function setReservationByNationalId(array $reservationByNationalId = array())
    {
        // validation for constraint: array
        if ('' !== ($reservationByNationalIdArrayErrorMessage = self::validateReservationByNationalIdForArrayConstraintsFromSetReservationByNationalId($reservationByNationalId))) {
            throw new \InvalidArgumentException($reservationByNationalIdArrayErrorMessage, __LINE__);
        }
        if (is_null($reservationByNationalId) || (is_array($reservationByNationalId) && empty($reservationByNationalId))) {
            unset($this->ReservationByNationalId);
        } else {
            $this->ReservationByNationalId = $reservationByNationalId;
        }
        return $this;
    }
    /**
     * Add item to ReservationByNationalId value
     * @throws \InvalidArgumentException
     * @param \StructType\ReservationByNationalId $item
     * @return \ArrayType\ArrayOfReservationByNationalId
     */
    public function addToReservationByNationalId(\StructType\ReservationByNationalId $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReservationByNationalId) {
            throw new \InvalidArgumentException(sprintf('The ReservationByNationalId property can only contain items of type \StructType\ReservationByNationalId, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReservationByNationalId[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ReservationByNationalId|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ReservationByNationalId|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ReservationByNationalId|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ReservationByNationalId|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ReservationByNationalId|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ReservationByNationalId
     */
    public function getAttributeName()
    {
        return 'ReservationByNationalId';
    }
}
