<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfReservationToInsertHistory ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfReservationToInsertHistory
 * @subpackage Arrays
 */
class ArrayOfReservationToInsertHistory extends AbstractStructArrayBase
{
    /**
     * The ReservationToInsertHistory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ReservationToInsertHistory[]
     */
    public $ReservationToInsertHistory;
    /**
     * Constructor method for ArrayOfReservationToInsertHistory
     * @uses ArrayOfReservationToInsertHistory::setReservationToInsertHistory()
     * @param \StructType\ReservationToInsertHistory[] $reservationToInsertHistory
     */
    public function __construct(array $reservationToInsertHistory = array())
    {
        $this
            ->setReservationToInsertHistory($reservationToInsertHistory);
    }
    /**
     * Get ReservationToInsertHistory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ReservationToInsertHistory[]|null
     */
    public function getReservationToInsertHistory()
    {
        return isset($this->ReservationToInsertHistory) ? $this->ReservationToInsertHistory : null;
    }
    /**
     * This method is responsible for validating the values passed to the setReservationToInsertHistory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReservationToInsertHistory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReservationToInsertHistoryForArrayConstraintsFromSetReservationToInsertHistory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfReservationToInsertHistoryReservationToInsertHistoryItem) {
            // validation for constraint: itemType
            if (!$arrayOfReservationToInsertHistoryReservationToInsertHistoryItem instanceof \StructType\ReservationToInsertHistory) {
                $invalidValues[] = is_object($arrayOfReservationToInsertHistoryReservationToInsertHistoryItem) ? get_class($arrayOfReservationToInsertHistoryReservationToInsertHistoryItem) : sprintf('%s(%s)', gettype($arrayOfReservationToInsertHistoryReservationToInsertHistoryItem), var_export($arrayOfReservationToInsertHistoryReservationToInsertHistoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReservationToInsertHistory property can only contain items of type \StructType\ReservationToInsertHistory, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReservationToInsertHistory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ReservationToInsertHistory[] $reservationToInsertHistory
     * @return \ArrayType\ArrayOfReservationToInsertHistory
     */
    public function setReservationToInsertHistory(array $reservationToInsertHistory = array())
    {
        // validation for constraint: array
        if ('' !== ($reservationToInsertHistoryArrayErrorMessage = self::validateReservationToInsertHistoryForArrayConstraintsFromSetReservationToInsertHistory($reservationToInsertHistory))) {
            throw new \InvalidArgumentException($reservationToInsertHistoryArrayErrorMessage, __LINE__);
        }
        if (is_null($reservationToInsertHistory) || (is_array($reservationToInsertHistory) && empty($reservationToInsertHistory))) {
            unset($this->ReservationToInsertHistory);
        } else {
            $this->ReservationToInsertHistory = $reservationToInsertHistory;
        }
        return $this;
    }
    /**
     * Add item to ReservationToInsertHistory value
     * @throws \InvalidArgumentException
     * @param \StructType\ReservationToInsertHistory $item
     * @return \ArrayType\ArrayOfReservationToInsertHistory
     */
    public function addToReservationToInsertHistory(\StructType\ReservationToInsertHistory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReservationToInsertHistory) {
            throw new \InvalidArgumentException(sprintf('The ReservationToInsertHistory property can only contain items of type \StructType\ReservationToInsertHistory, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReservationToInsertHistory[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ReservationToInsertHistory|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ReservationToInsertHistory|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ReservationToInsertHistory|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ReservationToInsertHistory|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ReservationToInsertHistory|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ReservationToInsertHistory
     */
    public function getAttributeName()
    {
        return 'ReservationToInsertHistory';
    }
}
