<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSpecialServiceToCancel ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSpecialServiceToCancel
 * @subpackage Arrays
 */
class ArrayOfSpecialServiceToCancel extends AbstractStructArrayBase
{
    /**
     * The SpecialServiceToCancel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SpecialServiceToCancel[]
     */
    public $SpecialServiceToCancel;
    /**
     * Constructor method for ArrayOfSpecialServiceToCancel
     * @uses ArrayOfSpecialServiceToCancel::setSpecialServiceToCancel()
     * @param \StructType\SpecialServiceToCancel[] $specialServiceToCancel
     */
    public function __construct(array $specialServiceToCancel = array())
    {
        $this
            ->setSpecialServiceToCancel($specialServiceToCancel);
    }
    /**
     * Get SpecialServiceToCancel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SpecialServiceToCancel[]|null
     */
    public function getSpecialServiceToCancel()
    {
        return isset($this->SpecialServiceToCancel) ? $this->SpecialServiceToCancel : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSpecialServiceToCancel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSpecialServiceToCancel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSpecialServiceToCancelForArrayConstraintsFromSetSpecialServiceToCancel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSpecialServiceToCancelSpecialServiceToCancelItem) {
            // validation for constraint: itemType
            if (!$arrayOfSpecialServiceToCancelSpecialServiceToCancelItem instanceof \StructType\SpecialServiceToCancel) {
                $invalidValues[] = is_object($arrayOfSpecialServiceToCancelSpecialServiceToCancelItem) ? get_class($arrayOfSpecialServiceToCancelSpecialServiceToCancelItem) : sprintf('%s(%s)', gettype($arrayOfSpecialServiceToCancelSpecialServiceToCancelItem), var_export($arrayOfSpecialServiceToCancelSpecialServiceToCancelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SpecialServiceToCancel property can only contain items of type \StructType\SpecialServiceToCancel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SpecialServiceToCancel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SpecialServiceToCancel[] $specialServiceToCancel
     * @return \ArrayType\ArrayOfSpecialServiceToCancel
     */
    public function setSpecialServiceToCancel(array $specialServiceToCancel = array())
    {
        // validation for constraint: array
        if ('' !== ($specialServiceToCancelArrayErrorMessage = self::validateSpecialServiceToCancelForArrayConstraintsFromSetSpecialServiceToCancel($specialServiceToCancel))) {
            throw new \InvalidArgumentException($specialServiceToCancelArrayErrorMessage, __LINE__);
        }
        if (is_null($specialServiceToCancel) || (is_array($specialServiceToCancel) && empty($specialServiceToCancel))) {
            unset($this->SpecialServiceToCancel);
        } else {
            $this->SpecialServiceToCancel = $specialServiceToCancel;
        }
        return $this;
    }
    /**
     * Add item to SpecialServiceToCancel value
     * @throws \InvalidArgumentException
     * @param \StructType\SpecialServiceToCancel $item
     * @return \ArrayType\ArrayOfSpecialServiceToCancel
     */
    public function addToSpecialServiceToCancel(\StructType\SpecialServiceToCancel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SpecialServiceToCancel) {
            throw new \InvalidArgumentException(sprintf('The SpecialServiceToCancel property can only contain items of type \StructType\SpecialServiceToCancel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SpecialServiceToCancel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SpecialServiceToCancel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SpecialServiceToCancel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SpecialServiceToCancel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SpecialServiceToCancel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SpecialServiceToCancel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SpecialServiceToCancel
     */
    public function getAttributeName()
    {
        return 'SpecialServiceToCancel';
    }
}
