<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewPNRModificationImpact ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewPNRModificationImpact
 * @subpackage Arrays
 */
class ArrayOfViewPNRModificationImpact extends AbstractStructArrayBase
{
    /**
     * The ViewPNRModificationImpact
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewPNRModificationImpact[]
     */
    public $ViewPNRModificationImpact;
    /**
     * Constructor method for ArrayOfViewPNRModificationImpact
     * @uses ArrayOfViewPNRModificationImpact::setViewPNRModificationImpact()
     * @param \StructType\ViewPNRModificationImpact[] $viewPNRModificationImpact
     */
    public function __construct(array $viewPNRModificationImpact = array())
    {
        $this
            ->setViewPNRModificationImpact($viewPNRModificationImpact);
    }
    /**
     * Get ViewPNRModificationImpact value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewPNRModificationImpact[]|null
     */
    public function getViewPNRModificationImpact()
    {
        return isset($this->ViewPNRModificationImpact) ? $this->ViewPNRModificationImpact : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewPNRModificationImpact method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewPNRModificationImpact method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewPNRModificationImpactForArrayConstraintsFromSetViewPNRModificationImpact(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewPNRModificationImpactViewPNRModificationImpactItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewPNRModificationImpactViewPNRModificationImpactItem instanceof \StructType\ViewPNRModificationImpact) {
                $invalidValues[] = is_object($arrayOfViewPNRModificationImpactViewPNRModificationImpactItem) ? get_class($arrayOfViewPNRModificationImpactViewPNRModificationImpactItem) : sprintf('%s(%s)', gettype($arrayOfViewPNRModificationImpactViewPNRModificationImpactItem), var_export($arrayOfViewPNRModificationImpactViewPNRModificationImpactItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewPNRModificationImpact property can only contain items of type \StructType\ViewPNRModificationImpact, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewPNRModificationImpact value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewPNRModificationImpact[] $viewPNRModificationImpact
     * @return \ArrayType\ArrayOfViewPNRModificationImpact
     */
    public function setViewPNRModificationImpact(array $viewPNRModificationImpact = array())
    {
        // validation for constraint: array
        if ('' !== ($viewPNRModificationImpactArrayErrorMessage = self::validateViewPNRModificationImpactForArrayConstraintsFromSetViewPNRModificationImpact($viewPNRModificationImpact))) {
            throw new \InvalidArgumentException($viewPNRModificationImpactArrayErrorMessage, __LINE__);
        }
        if (is_null($viewPNRModificationImpact) || (is_array($viewPNRModificationImpact) && empty($viewPNRModificationImpact))) {
            unset($this->ViewPNRModificationImpact);
        } else {
            $this->ViewPNRModificationImpact = $viewPNRModificationImpact;
        }
        return $this;
    }
    /**
     * Add item to ViewPNRModificationImpact value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewPNRModificationImpact $item
     * @return \ArrayType\ArrayOfViewPNRModificationImpact
     */
    public function addToViewPNRModificationImpact(\StructType\ViewPNRModificationImpact $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewPNRModificationImpact) {
            throw new \InvalidArgumentException(sprintf('The ViewPNRModificationImpact property can only contain items of type \StructType\ViewPNRModificationImpact, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewPNRModificationImpact[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewPNRModificationImpact|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewPNRModificationImpact|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewPNRModificationImpact|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewPNRModificationImpact|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewPNRModificationImpact|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewPNRModificationImpact
     */
    public function getAttributeName()
    {
        return 'ViewPNRModificationImpact';
    }
}
