<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'CreatePNR' => '\\StructType\\CreatePNR',
            'CreatePNRResponse' => '\\StructType\\CreatePNRResponse',
            'SummaryPNR' => '\\StructType\\SummaryPNR',
            'SummaryPNRResponse' => '\\StructType\\SummaryPNRResponse',
            'ModifyPNR' => '\\StructType\\ModifyPNR',
            'ModifyPNRResponse' => '\\StructType\\ModifyPNRResponse',
            'CancelPNR' => '\\StructType\\CancelPNR',
            'CancelPNRResponse' => '\\StructType\\CancelPNRResponse',
            'RetrievePNR' => '\\StructType\\RetrievePNR',
            'RetrievePNRResponse' => '\\StructType\\RetrievePNRResponse',
            'ImportPNR' => '\\StructType\\ImportPNR',
            'ImportPNRResponse' => '\\StructType\\ImportPNRResponse',
            'HistoryPNR' => '\\StructType\\HistoryPNR',
            'HistoryPNRResponse' => '\\StructType\\HistoryPNRResponse',
            'EvaluateModificationOfPNR' => '\\StructType\\EvaluateModificationOfPNR',
            'EvaluateModificationOfPNRResponse' => '\\StructType\\EvaluateModificationOfPNRResponse',
            'AddPenalties' => '\\StructType\\AddPenalties',
            'AddPenaltiesResponse' => '\\StructType\\AddPenaltiesResponse',
            'AddTaxes' => '\\StructType\\AddTaxes',
            'AddTaxesResponse' => '\\StructType\\AddTaxesResponse',
            'OverrideReservationCharges' => '\\StructType\\OverrideReservationCharges',
            'OverrideReservationChargesResponse' => '\\StructType\\OverrideReservationChargesResponse',
            'AddUpdateApisInfo' => '\\StructType\\AddUpdateApisInfo',
            'AddUpdateApisInfoResponse' => '\\StructType\\AddUpdateApisInfoResponse',
            'RetrieveApisInfo' => '\\StructType\\RetrieveApisInfo',
            'RetrieveApisInfoResponse' => '\\StructType\\RetrieveApisInfoResponse',
            'GetReservationsByNationalId' => '\\StructType\\GetReservationsByNationalId',
            'GetReservationsByNationalIdResponse' => '\\StructType\\GetReservationsByNationalIdResponse',
            'ProcessFlightDisruptionAlert' => '\\StructType\\ProcessFlightDisruptionAlert',
            'ProcessFlightDisruptionAlertResponse' => '\\StructType\\ProcessFlightDisruptionAlertResponse',
            'RetrievePNRByRecordLocator' => '\\StructType\\RetrievePNRByRecordLocator',
            'RetrievePNRByRecordLocatorResponse' => '\\StructType\\RetrievePNRByRecordLocatorResponse',
            'OAFlightSegments' => '\\StructType\\OAFlightSegments',
            'OAFlightSegmentsResponse' => '\\StructType\\OAFlightSegmentsResponse',
            'ManualRefundCharges' => '\\StructType\\ManualRefundCharges',
            'ManualRefundChargesResponse' => '\\StructType\\ManualRefundChargesResponse',
            'Address' => '\\StructType\\Address',
            'ArrayOfContactInfo' => '\\ArrayType\\ArrayOfContactInfo',
            'ContactInfo' => '\\StructType\\ContactInfo',
            'ArrayOfPerson' => '\\ArrayType\\ArrayOfPerson',
            'Person' => '\\StructType\\Person',
            'ArrayOfSegment' => '\\ArrayType\\ArrayOfSegment',
            'Segment' => '\\StructType\\Segment',
            'ArrayOfSpecialService' => '\\ArrayType\\ArrayOfSpecialService',
            'SpecialService' => '\\StructType\\SpecialService',
            'ArrayOfSeat' => '\\ArrayType\\ArrayOfSeat',
            'Seat' => '\\StructType\\Seat',
            'ArrayOfPayment' => '\\ArrayType\\ArrayOfPayment',
            'Payment' => '\\StructType\\Payment',
            'ArrayOfModifyPNR.Passenger' => '\\ArrayType\\ArrayOfModifyPNR_Passenger',
            'ModifyPNR.Passenger' => '\\StructType\\ModifyPNR_Passenger',
            'ModifyPNR.Person' => '\\StructType\\ModifyPNR_Person',
            'ArrayOfModifyPNR.FlightInformation' => '\\ArrayType\\ArrayOfModifyPNR_FlightInformation',
            'ModifyPNR.FlightInformation' => '\\StructType\\ModifyPNR_FlightInformation',
            'ArrayOfModifyPNR.UpdatePassenger' => '\\ArrayType\\ArrayOfModifyPNR_UpdatePassenger',
            'ModifyPNR.UpdatePassenger' => '\\StructType\\ModifyPNR_UpdatePassenger',
            'ArrayOfSpecialServiceToCancel' => '\\ArrayType\\ArrayOfSpecialServiceToCancel',
            'SpecialServiceToCancel' => '\\StructType\\SpecialServiceToCancel',
            'ArrayOfModifyPNR.AddContactInfo' => '\\ArrayType\\ArrayOfModifyPNR_AddContactInfo',
            'ModifyPNR.AddContactInfo' => '\\StructType\\ModifyPNR_AddContactInfo',
            'ArrayOfModifyPNR.UpdateContactInfo' => '\\ArrayType\\ArrayOfModifyPNR_UpdateContactInfo',
            'ModifyPNR.UpdateContactInfo' => '\\StructType\\ModifyPNR_UpdateContactInfo',
            'Comment' => '\\StructType\\Comment',
            'ArrayOfModifyPNR.EmergencyContact' => '\\ArrayType\\ArrayOfModifyPNR_EmergencyContact',
            'ModifyPNR.EmergencyContact' => '\\StructType\\ModifyPNR_EmergencyContact',
            'ArrayOfModifyPNR.UpdatePassengerGrouping' => '\\ArrayType\\ArrayOfModifyPNR_UpdatePassengerGrouping',
            'ModifyPNR.UpdatePassengerGrouping' => '\\StructType\\ModifyPNR_UpdatePassengerGrouping',
            'ArrayOfModifyPNR.UpdateRecordLocator' => '\\ArrayType\\ArrayOfModifyPNR_UpdateRecordLocator',
            'ModifyPNR.UpdateRecordLocator' => '\\StructType\\ModifyPNR_UpdateRecordLocator',
            'ArrayOfModifyPNR.UpdateTravelsWithPersonOrg' => '\\ArrayType\\ArrayOfModifyPNR_UpdateTravelsWithPersonOrg',
            'ModifyPNR.UpdateTravelsWithPersonOrg' => '\\StructType\\ModifyPNR_UpdateTravelsWithPersonOrg',
            'ImportPNR.Reservation' => '\\StructType\\ImportPNR_Reservation',
            'ArrayOfImportPNR.Reservation.Segment' => '\\ArrayType\\ArrayOfImportPNR_Reservation_Segment',
            'ImportPNR.Reservation.Segment' => '\\StructType\\ImportPNR_Reservation_Segment',
            'ArrayOfImportPNR.Reservation.Segment.AirlinePerson' => '\\ArrayType\\ArrayOfImportPNR_Reservation_Segment_AirlinePerson',
            'ImportPNR.Reservation.Segment.AirlinePerson' => '\\StructType\\ImportPNR_Reservation_Segment_AirlinePerson',
            'ArrayOfImportPNR.Reservation.Segment.AirlinePerson.Charge' => '\\ArrayType\\ArrayOfImportPNR_Reservation_Segment_AirlinePerson_Charge',
            'ImportPNR.Reservation.Segment.AirlinePerson.Charge' => '\\StructType\\ImportPNR_Reservation_Segment_AirlinePerson_Charge',
            'ArrayOfImportPNR.Reservation.Segment.AirlinePerson.Seat' => '\\ArrayType\\ArrayOfImportPNR_Reservation_Segment_AirlinePerson_Seat',
            'ImportPNR.Reservation.Segment.AirlinePerson.Seat' => '\\StructType\\ImportPNR_Reservation_Segment_AirlinePerson_Seat',
            'ArrayOfImportPNR.Reservation.Person' => '\\ArrayType\\ArrayOfImportPNR_Reservation_Person',
            'ImportPNR.Reservation.Person' => '\\StructType\\ImportPNR_Reservation_Person',
            'ArrayOfImportPNR.Reservation.Person.ApisInformation' => '\\ArrayType\\ArrayOfImportPNR_Reservation_Person_ApisInformation',
            'ImportPNR.Reservation.Person.ApisInformation' => '\\StructType\\ImportPNR_Reservation_Person_ApisInformation',
            'ArrayOfImportPNR.Reservation.Comment' => '\\ArrayType\\ArrayOfImportPNR_Reservation_Comment',
            'ImportPNR.Reservation.Comment' => '\\StructType\\ImportPNR_Reservation_Comment',
            'ArrayOfImportPNR.Reservation.ImportError' => '\\ArrayType\\ArrayOfImportPNR_Reservation_ImportError',
            'ImportPNR.Reservation.ImportError' => '\\StructType\\ImportPNR_Reservation_ImportError',
            'ArrayOfOALSegment' => '\\ArrayType\\ArrayOfOALSegment',
            'OALSegment' => '\\StructType\\OALSegment',
            'ArrayOfOALAirlinePerson' => '\\ArrayType\\ArrayOfOALAirlinePerson',
            'OALAirlinePerson' => '\\StructType\\OALAirlinePerson',
            'ArrayOfReservationToInsertHistory' => '\\ArrayType\\ArrayOfReservationToInsertHistory',
            'ReservationToInsertHistory' => '\\StructType\\ReservationToInsertHistory',
            'AddPenalty' => '\\StructType\\AddPenalty',
            'ArrayOfAddPenaltyDetail' => '\\ArrayType\\ArrayOfAddPenaltyDetail',
            'AddPenaltyDetail' => '\\StructType\\AddPenaltyDetail',
            'OverrideChargeBase' => '\\StructType\\OverrideChargeBase',
            'AddTax' => '\\StructType\\AddTax',
            'ArrayOfAddTaxDetail' => '\\ArrayType\\ArrayOfAddTaxDetail',
            'AddTaxDetail' => '\\StructType\\AddTaxDetail',
            'ArrayOfOverrideChargeDetail' => '\\ArrayType\\ArrayOfOverrideChargeDetail',
            'OverrideChargeDetail' => '\\StructType\\OverrideChargeDetail',
            'ApisInfos' => '\\StructType\\ApisInfos',
            'ArrayOfApisInformation' => '\\ArrayType\\ArrayOfApisInformation',
            'ApisInformation' => '\\StructType\\ApisInformation',
            'ArrayOfRefundChargeDetail' => '\\ArrayType\\ArrayOfRefundChargeDetail',
            'RefundChargeDetail' => '\\StructType\\RefundChargeDetail',
            'TransactionInfo' => '\\StructType\\TransactionInfo',
            'ArrayOfCarrierCode' => '\\ArrayType\\ArrayOfCarrierCode',
            'CarrierCode' => '\\StructType\\CarrierCode',
            'ReservationInfo' => '\\StructType\\ReservationInfo',
            'ViewPNR' => '\\StructType\\ViewPNR',
            'ArrayOfAirline' => '\\ArrayType\\ArrayOfAirline',
            'Airline' => '\\StructType\\Airline',
            'ArrayOfLogicalFlight' => '\\ArrayType\\ArrayOfLogicalFlight',
            'LogicalFlight' => '\\StructType\\LogicalFlight',
            'ArrayOfPhysicalFlight' => '\\ArrayType\\ArrayOfPhysicalFlight',
            'PhysicalFlight' => '\\StructType\\PhysicalFlight',
            'ArrayOfCustomer' => '\\ArrayType\\ArrayOfCustomer',
            'Customer' => '\\StructType\\Customer',
            'ArrayOfAirlinePerson' => '\\ArrayType\\ArrayOfAirlinePerson',
            'AirlinePerson' => '\\StructType\\AirlinePerson',
            'ArrayOfSeatAssignment' => '\\ArrayType\\ArrayOfSeatAssignment',
            'SeatAssignment' => '\\StructType\\SeatAssignment',
            'ArrayOfSeatAttribute' => '\\ArrayType\\ArrayOfSeatAttribute',
            'SeatAttribute' => '\\StructType\\SeatAttribute',
            'ArrayOfCharge' => '\\ArrayType\\ArrayOfCharge',
            'Charge' => '\\StructType\\Charge',
            'ArrayOfReservationPaymentMap' => '\\ArrayType\\ArrayOfReservationPaymentMap',
            'ReservationPaymentMap' => '\\StructType\\ReservationPaymentMap',
            'ArrayOfBaggage' => '\\ArrayType\\ArrayOfBaggage',
            'Baggage' => '\\StructType\\Baggage',
            'ArrayOfOAFlight' => '\\ArrayType\\ArrayOfOAFlight',
            'OAFlight' => '\\StructType\\OAFlight',
            'ArrayOfOAFlightPerson' => '\\ArrayType\\ArrayOfOAFlightPerson',
            'OAFlightPerson' => '\\StructType\\OAFlightPerson',
            'ArrayOfHistory' => '\\ArrayType\\ArrayOfHistory',
            'History' => '\\StructType\\History',
            'ArrayOfComment' => '\\ArrayType\\ArrayOfComment',
            'ArrayOfGDSHistory' => '\\ArrayType\\ArrayOfGDSHistory',
            'GDSHistory' => '\\StructType\\GDSHistory',
            'ArrayOfReservationContact' => '\\ArrayType\\ArrayOfReservationContact',
            'ReservationContact' => '\\StructType\\ReservationContact',
            'ArrayOfVoucher' => '\\ArrayType\\ArrayOfVoucher',
            'Voucher' => '\\StructType\\Voucher',
            'ArrayOfCar' => '\\ArrayType\\ArrayOfCar',
            'Car' => '\\StructType\\Car',
            'ArrayOfHotel' => '\\ArrayType\\ArrayOfHotel',
            'Hotel' => '\\StructType\\Hotel',
            'ArrayOfPackage' => '\\ArrayType\\ArrayOfPackage',
            'Package' => '\\StructType\\Package',
            'ViewImportPNR' => '\\StructType\\ViewImportPNR',
            'ViewImportPNR.Reservation' => '\\StructType\\ViewImportPNR_Reservation',
            'ArrayOfViewImportPNR.Reservation.Segment' => '\\ArrayType\\ArrayOfViewImportPNR_Reservation_Segment',
            'ViewImportPNR.Reservation.Segment' => '\\StructType\\ViewImportPNR_Reservation_Segment',
            'ArrayOfViewImportPNR.Reservation.Segment.AirlinePerson' => '\\ArrayType\\ArrayOfViewImportPNR_Reservation_Segment_AirlinePerson',
            'ViewImportPNR.Reservation.Segment.AirlinePerson' => '\\StructType\\ViewImportPNR_Reservation_Segment_AirlinePerson',
            'ArrayOfViewImportPNR.Reservation.Segment.AirlinePerson.Charge' => '\\ArrayType\\ArrayOfViewImportPNR_Reservation_Segment_AirlinePerson_Charge',
            'ViewImportPNR.Reservation.Segment.AirlinePerson.Charge' => '\\StructType\\ViewImportPNR_Reservation_Segment_AirlinePerson_Charge',
            'ArrayOfViewImportPNR.Reservation.Segment.AirlinePerson.Seat' => '\\ArrayType\\ArrayOfViewImportPNR_Reservation_Segment_AirlinePerson_Seat',
            'ViewImportPNR.Reservation.Segment.AirlinePerson.Seat' => '\\StructType\\ViewImportPNR_Reservation_Segment_AirlinePerson_Seat',
            'ArrayOfViewImportPNR.Reservation.Person' => '\\ArrayType\\ArrayOfViewImportPNR_Reservation_Person',
            'ViewImportPNR.Reservation.Person' => '\\StructType\\ViewImportPNR_Reservation_Person',
            'ArrayOfViewImportPNR.Reservation.Person.ApisInformation' => '\\ArrayType\\ArrayOfViewImportPNR_Reservation_Person_ApisInformation',
            'ViewImportPNR.Reservation.Person.ApisInformation' => '\\StructType\\ViewImportPNR_Reservation_Person_ApisInformation',
            'ArrayOfViewImportPNR.Reservation.Comment' => '\\ArrayType\\ArrayOfViewImportPNR_Reservation_Comment',
            'ViewImportPNR.Reservation.Comment' => '\\StructType\\ViewImportPNR_Reservation_Comment',
            'ArrayOfViewImportPNR.Reservation.ImportError' => '\\ArrayType\\ArrayOfViewImportPNR_Reservation_ImportError',
            'ViewImportPNR.Reservation.ImportError' => '\\StructType\\ViewImportPNR_Reservation_ImportError',
            'ViewHistoryPNRCollection' => '\\StructType\\ViewHistoryPNRCollection',
            'ArrayOfViewHistoryPNR' => '\\ArrayType\\ArrayOfViewHistoryPNR',
            'ViewHistoryPNR' => '\\StructType\\ViewHistoryPNR',
            'ViewPNRModificationImpactCollection' => '\\StructType\\ViewPNRModificationImpactCollection',
            'ArrayOfViewPNRModificationImpact' => '\\ArrayType\\ArrayOfViewPNRModificationImpact',
            'ViewPNRModificationImpact' => '\\StructType\\ViewPNRModificationImpact',
            'ViewApisInfo' => '\\StructType\\ViewApisInfo',
            'ViewReservationsByNationalId' => '\\StructType\\ViewReservationsByNationalId',
            'ArrayOfReservationByNationalId' => '\\ArrayType\\ArrayOfReservationByNationalId',
            'ReservationByNationalId' => '\\StructType\\ReservationByNationalId',
            'ArrayOfFlightSegment' => '\\ArrayType\\ArrayOfFlightSegment',
            'FlightSegment' => '\\StructType\\FlightSegment',
            'ArrayOfPaymentMetaData' => '\\ArrayType\\ArrayOfPaymentMetaData',
            'PaymentMetaData' => '\\StructType\\PaymentMetaData',
            'ExceptionInformation.Exceptions' => '\\StructType\\ExceptionInformation_Exceptions',
            'ExceptionInformation.Exception' => '\\StructType\\ExceptionInformation_Exception',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'ArrayOfint' => '\\ArrayType\\ArrayOfint',
        );
    }
}
