<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for ManualRefundCharges.RefundOptions EnumType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ManualRefundCharges.RefundOptions
 * @subpackage Enumerations
 */
class ManualRefundCharges_RefundOptions extends AbstractStructEnumBase
{
    /**
     * Constant for value 'RefundAsPaid'
     * @return string 'RefundAsPaid'
     */
    const VALUE_REFUND_AS_PAID = 'RefundAsPaid';
    /**
     * Constant for value 'RefundToVoucherPayer'
     * @return string 'RefundToVoucherPayer'
     */
    const VALUE_REFUND_TO_VOUCHER_PAYER = 'RefundToVoucherPayer';
    /**
     * Constant for value 'RefundToVoucherFlyer'
     * @return string 'RefundToVoucherFlyer'
     */
    const VALUE_REFUND_TO_VOUCHER_FLYER = 'RefundToVoucherFlyer';
    /**
     * Constant for value 'RefundToAccounting'
     * @return string 'RefundToAccounting'
     */
    const VALUE_REFUND_TO_ACCOUNTING = 'RefundToAccounting';
    /**
     * Constant for value 'RefundToPendingQueue'
     * @return string 'RefundToPendingQueue'
     */
    const VALUE_REFUND_TO_PENDING_QUEUE = 'RefundToPendingQueue';
    /**
     * Constant for value 'RefundToInvoice'
     * @return string 'RefundToInvoice'
     */
    const VALUE_REFUND_TO_INVOICE = 'RefundToInvoice';
    /**
     * Constant for value 'DefaultRefund'
     * @return string 'DefaultRefund'
     */
    const VALUE_DEFAULT_REFUND = 'DefaultRefund';
    /**
     * Return allowed values
     * @uses self::VALUE_REFUND_AS_PAID
     * @uses self::VALUE_REFUND_TO_VOUCHER_PAYER
     * @uses self::VALUE_REFUND_TO_VOUCHER_FLYER
     * @uses self::VALUE_REFUND_TO_ACCOUNTING
     * @uses self::VALUE_REFUND_TO_PENDING_QUEUE
     * @uses self::VALUE_REFUND_TO_INVOICE
     * @uses self::VALUE_DEFAULT_REFUND
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_REFUND_AS_PAID,
            self::VALUE_REFUND_TO_VOUCHER_PAYER,
            self::VALUE_REFUND_TO_VOUCHER_FLYER,
            self::VALUE_REFUND_TO_ACCOUNTING,
            self::VALUE_REFUND_TO_PENDING_QUEUE,
            self::VALUE_REFUND_TO_INVOICE,
            self::VALUE_DEFAULT_REFUND,
        );
    }
}
