<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ImportPNR.Reservation.Segment StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ImportPNR.Reservation.Segment
 * @subpackage Structs
 */
class ImportPNR_Reservation_Segment extends AbstractStructBase
{
    /**
     * The CarrierCode
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $CarrierCode;
    /**
     * The FlightNumber
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $FlightNumber;
    /**
     * The DepartureDate
     * @var string
     */
    public $DepartureDate;
    /**
     * The Origin
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Origin;
    /**
     * The OriginName
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $OriginName;
    /**
     * The Destination
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Destination;
    /**
     * The DestinationName
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $DestinationName;
    /**
     * The DepartureTime
     * @var string
     */
    public $DepartureTime;
    /**
     * The ArrivalTime
     * @var string
     */
    public $ArrivalTime;
    /**
     * The AirlinePersons
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfImportPNR_Reservation_Segment_AirlinePerson
     */
    public $AirlinePersons;
    /**
     * Constructor method for ImportPNR.Reservation.Segment
     * @uses ImportPNR_Reservation_Segment::setCarrierCode()
     * @uses ImportPNR_Reservation_Segment::setFlightNumber()
     * @uses ImportPNR_Reservation_Segment::setDepartureDate()
     * @uses ImportPNR_Reservation_Segment::setOrigin()
     * @uses ImportPNR_Reservation_Segment::setOriginName()
     * @uses ImportPNR_Reservation_Segment::setDestination()
     * @uses ImportPNR_Reservation_Segment::setDestinationName()
     * @uses ImportPNR_Reservation_Segment::setDepartureTime()
     * @uses ImportPNR_Reservation_Segment::setArrivalTime()
     * @uses ImportPNR_Reservation_Segment::setAirlinePersons()
     * @param string $carrierCode
     * @param string $flightNumber
     * @param string $departureDate
     * @param string $origin
     * @param string $originName
     * @param string $destination
     * @param string $destinationName
     * @param string $departureTime
     * @param string $arrivalTime
     * @param \ArrayType\ArrayOfImportPNR_Reservation_Segment_AirlinePerson $airlinePersons
     */
    public function __construct($carrierCode = null, $flightNumber = null, $departureDate = null, $origin = null, $originName = null, $destination = null, $destinationName = null, $departureTime = null, $arrivalTime = null, \ArrayType\ArrayOfImportPNR_Reservation_Segment_AirlinePerson $airlinePersons = null)
    {
        $this
            ->setCarrierCode($carrierCode)
            ->setFlightNumber($flightNumber)
            ->setDepartureDate($departureDate)
            ->setOrigin($origin)
            ->setOriginName($originName)
            ->setDestination($destination)
            ->setDestinationName($destinationName)
            ->setDepartureTime($departureTime)
            ->setArrivalTime($arrivalTime)
            ->setAirlinePersons($airlinePersons);
    }
    /**
     * Get CarrierCode value
     * @return string|null
     */
    public function getCarrierCode()
    {
        return $this->CarrierCode;
    }
    /**
     * Set CarrierCode value
     * @param string $carrierCode
     * @return \StructType\ImportPNR_Reservation_Segment
     */
    public function setCarrierCode($carrierCode = null)
    {
        // validation for constraint: string
        if (!is_null($carrierCode) && !is_string($carrierCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($carrierCode, true), gettype($carrierCode)), __LINE__);
        }
        $this->CarrierCode = $carrierCode;
        return $this;
    }
    /**
     * Get FlightNumber value
     * @return string|null
     */
    public function getFlightNumber()
    {
        return $this->FlightNumber;
    }
    /**
     * Set FlightNumber value
     * @param string $flightNumber
     * @return \StructType\ImportPNR_Reservation_Segment
     */
    public function setFlightNumber($flightNumber = null)
    {
        // validation for constraint: string
        if (!is_null($flightNumber) && !is_string($flightNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($flightNumber, true), gettype($flightNumber)), __LINE__);
        }
        $this->FlightNumber = $flightNumber;
        return $this;
    }
    /**
     * Get DepartureDate value
     * @return string|null
     */
    public function getDepartureDate()
    {
        return $this->DepartureDate;
    }
    /**
     * Set DepartureDate value
     * @param string $departureDate
     * @return \StructType\ImportPNR_Reservation_Segment
     */
    public function setDepartureDate($departureDate = null)
    {
        // validation for constraint: string
        if (!is_null($departureDate) && !is_string($departureDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($departureDate, true), gettype($departureDate)), __LINE__);
        }
        $this->DepartureDate = $departureDate;
        return $this;
    }
    /**
     * Get Origin value
     * @return string|null
     */
    public function getOrigin()
    {
        return $this->Origin;
    }
    /**
     * Set Origin value
     * @param string $origin
     * @return \StructType\ImportPNR_Reservation_Segment
     */
    public function setOrigin($origin = null)
    {
        // validation for constraint: string
        if (!is_null($origin) && !is_string($origin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($origin, true), gettype($origin)), __LINE__);
        }
        $this->Origin = $origin;
        return $this;
    }
    /**
     * Get OriginName value
     * @return string|null
     */
    public function getOriginName()
    {
        return $this->OriginName;
    }
    /**
     * Set OriginName value
     * @param string $originName
     * @return \StructType\ImportPNR_Reservation_Segment
     */
    public function setOriginName($originName = null)
    {
        // validation for constraint: string
        if (!is_null($originName) && !is_string($originName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originName, true), gettype($originName)), __LINE__);
        }
        $this->OriginName = $originName;
        return $this;
    }
    /**
     * Get Destination value
     * @return string|null
     */
    public function getDestination()
    {
        return $this->Destination;
    }
    /**
     * Set Destination value
     * @param string $destination
     * @return \StructType\ImportPNR_Reservation_Segment
     */
    public function setDestination($destination = null)
    {
        // validation for constraint: string
        if (!is_null($destination) && !is_string($destination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($destination, true), gettype($destination)), __LINE__);
        }
        $this->Destination = $destination;
        return $this;
    }
    /**
     * Get DestinationName value
     * @return string|null
     */
    public function getDestinationName()
    {
        return $this->DestinationName;
    }
    /**
     * Set DestinationName value
     * @param string $destinationName
     * @return \StructType\ImportPNR_Reservation_Segment
     */
    public function setDestinationName($destinationName = null)
    {
        // validation for constraint: string
        if (!is_null($destinationName) && !is_string($destinationName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($destinationName, true), gettype($destinationName)), __LINE__);
        }
        $this->DestinationName = $destinationName;
        return $this;
    }
    /**
     * Get DepartureTime value
     * @return string|null
     */
    public function getDepartureTime()
    {
        return $this->DepartureTime;
    }
    /**
     * Set DepartureTime value
     * @param string $departureTime
     * @return \StructType\ImportPNR_Reservation_Segment
     */
    public function setDepartureTime($departureTime = null)
    {
        // validation for constraint: string
        if (!is_null($departureTime) && !is_string($departureTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($departureTime, true), gettype($departureTime)), __LINE__);
        }
        $this->DepartureTime = $departureTime;
        return $this;
    }
    /**
     * Get ArrivalTime value
     * @return string|null
     */
    public function getArrivalTime()
    {
        return $this->ArrivalTime;
    }
    /**
     * Set ArrivalTime value
     * @param string $arrivalTime
     * @return \StructType\ImportPNR_Reservation_Segment
     */
    public function setArrivalTime($arrivalTime = null)
    {
        // validation for constraint: string
        if (!is_null($arrivalTime) && !is_string($arrivalTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($arrivalTime, true), gettype($arrivalTime)), __LINE__);
        }
        $this->ArrivalTime = $arrivalTime;
        return $this;
    }
    /**
     * Get AirlinePersons value
     * @return \ArrayType\ArrayOfImportPNR_Reservation_Segment_AirlinePerson|null
     */
    public function getAirlinePersons()
    {
        return $this->AirlinePersons;
    }
    /**
     * Set AirlinePersons value
     * @param \ArrayType\ArrayOfImportPNR_Reservation_Segment_AirlinePerson $airlinePersons
     * @return \StructType\ImportPNR_Reservation_Segment
     */
    public function setAirlinePersons(\ArrayType\ArrayOfImportPNR_Reservation_Segment_AirlinePerson $airlinePersons = null)
    {
        $this->AirlinePersons = $airlinePersons;
        return $this;
    }
}
