<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ModifyPNR.UpdateRecordLocator StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ModifyPNR.UpdateRecordLocator
 * @subpackage Structs
 */
class ModifyPNR_UpdateRecordLocator extends AbstractStructBase
{
    /**
     * The RecordLocator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RecordLocator;
    /**
     * The ReservationKey
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ReservationKey;
    /**
     * The LogicalFlightKey
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $LogicalFlightKey;
    /**
     * The PhysicalFlightKey
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $PhysicalFlightKey;
    /**
     * The CustomerKey
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $CustomerKey;
    /**
     * The AirlinePersonKey
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $AirlinePersonKey;
    /**
     * The CRSCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CRSCode;
    /**
     * Constructor method for ModifyPNR.UpdateRecordLocator
     * @uses ModifyPNR_UpdateRecordLocator::setRecordLocator()
     * @uses ModifyPNR_UpdateRecordLocator::setReservationKey()
     * @uses ModifyPNR_UpdateRecordLocator::setLogicalFlightKey()
     * @uses ModifyPNR_UpdateRecordLocator::setPhysicalFlightKey()
     * @uses ModifyPNR_UpdateRecordLocator::setCustomerKey()
     * @uses ModifyPNR_UpdateRecordLocator::setAirlinePersonKey()
     * @uses ModifyPNR_UpdateRecordLocator::setCRSCode()
     * @param string $recordLocator
     * @param string $reservationKey
     * @param string $logicalFlightKey
     * @param string $physicalFlightKey
     * @param string $customerKey
     * @param string $airlinePersonKey
     * @param string $cRSCode
     */
    public function __construct($recordLocator = null, $reservationKey = null, $logicalFlightKey = null, $physicalFlightKey = null, $customerKey = null, $airlinePersonKey = null, $cRSCode = null)
    {
        $this
            ->setRecordLocator($recordLocator)
            ->setReservationKey($reservationKey)
            ->setLogicalFlightKey($logicalFlightKey)
            ->setPhysicalFlightKey($physicalFlightKey)
            ->setCustomerKey($customerKey)
            ->setAirlinePersonKey($airlinePersonKey)
            ->setCRSCode($cRSCode);
    }
    /**
     * Get RecordLocator value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRecordLocator()
    {
        return isset($this->RecordLocator) ? $this->RecordLocator : null;
    }
    /**
     * Set RecordLocator value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $recordLocator
     * @return \StructType\ModifyPNR_UpdateRecordLocator
     */
    public function setRecordLocator($recordLocator = null)
    {
        // validation for constraint: string
        if (!is_null($recordLocator) && !is_string($recordLocator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($recordLocator, true), gettype($recordLocator)), __LINE__);
        }
        if (is_null($recordLocator) || (is_array($recordLocator) && empty($recordLocator))) {
            unset($this->RecordLocator);
        } else {
            $this->RecordLocator = $recordLocator;
        }
        return $this;
    }
    /**
     * Get ReservationKey value
     * @return string|null
     */
    public function getReservationKey()
    {
        return $this->ReservationKey;
    }
    /**
     * Set ReservationKey value
     * @param string $reservationKey
     * @return \StructType\ModifyPNR_UpdateRecordLocator
     */
    public function setReservationKey($reservationKey = null)
    {
        // validation for constraint: string
        if (!is_null($reservationKey) && !is_string($reservationKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reservationKey, true), gettype($reservationKey)), __LINE__);
        }
        $this->ReservationKey = $reservationKey;
        return $this;
    }
    /**
     * Get LogicalFlightKey value
     * @return string|null
     */
    public function getLogicalFlightKey()
    {
        return $this->LogicalFlightKey;
    }
    /**
     * Set LogicalFlightKey value
     * @param string $logicalFlightKey
     * @return \StructType\ModifyPNR_UpdateRecordLocator
     */
    public function setLogicalFlightKey($logicalFlightKey = null)
    {
        // validation for constraint: string
        if (!is_null($logicalFlightKey) && !is_string($logicalFlightKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($logicalFlightKey, true), gettype($logicalFlightKey)), __LINE__);
        }
        $this->LogicalFlightKey = $logicalFlightKey;
        return $this;
    }
    /**
     * Get PhysicalFlightKey value
     * @return string|null
     */
    public function getPhysicalFlightKey()
    {
        return $this->PhysicalFlightKey;
    }
    /**
     * Set PhysicalFlightKey value
     * @param string $physicalFlightKey
     * @return \StructType\ModifyPNR_UpdateRecordLocator
     */
    public function setPhysicalFlightKey($physicalFlightKey = null)
    {
        // validation for constraint: string
        if (!is_null($physicalFlightKey) && !is_string($physicalFlightKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($physicalFlightKey, true), gettype($physicalFlightKey)), __LINE__);
        }
        $this->PhysicalFlightKey = $physicalFlightKey;
        return $this;
    }
    /**
     * Get CustomerKey value
     * @return string|null
     */
    public function getCustomerKey()
    {
        return $this->CustomerKey;
    }
    /**
     * Set CustomerKey value
     * @param string $customerKey
     * @return \StructType\ModifyPNR_UpdateRecordLocator
     */
    public function setCustomerKey($customerKey = null)
    {
        // validation for constraint: string
        if (!is_null($customerKey) && !is_string($customerKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerKey, true), gettype($customerKey)), __LINE__);
        }
        $this->CustomerKey = $customerKey;
        return $this;
    }
    /**
     * Get AirlinePersonKey value
     * @return string|null
     */
    public function getAirlinePersonKey()
    {
        return $this->AirlinePersonKey;
    }
    /**
     * Set AirlinePersonKey value
     * @param string $airlinePersonKey
     * @return \StructType\ModifyPNR_UpdateRecordLocator
     */
    public function setAirlinePersonKey($airlinePersonKey = null)
    {
        // validation for constraint: string
        if (!is_null($airlinePersonKey) && !is_string($airlinePersonKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($airlinePersonKey, true), gettype($airlinePersonKey)), __LINE__);
        }
        $this->AirlinePersonKey = $airlinePersonKey;
        return $this;
    }
    /**
     * Get CRSCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCRSCode()
    {
        return isset($this->CRSCode) ? $this->CRSCode : null;
    }
    /**
     * Set CRSCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cRSCode
     * @return \StructType\ModifyPNR_UpdateRecordLocator
     */
    public function setCRSCode($cRSCode = null)
    {
        // validation for constraint: string
        if (!is_null($cRSCode) && !is_string($cRSCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cRSCode, true), gettype($cRSCode)), __LINE__);
        }
        if (is_null($cRSCode) || (is_array($cRSCode) && empty($cRSCode))) {
            unset($this->CRSCode);
        } else {
            $this->CRSCode = $cRSCode;
        }
        return $this;
    }
}
