<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SpecialServiceToCancel StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SpecialServiceToCancel
 * @subpackage Structs
 */
class SpecialServiceToCancel extends AbstractStructBase
{
    /**
     * The AirlineKey
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $AirlineKey;
    /**
     * The LogicalFlightKey
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $LogicalFlightKey;
    /**
     * The PhysicalFlightKey
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $PhysicalFlightKey;
    /**
     * The CustomerKey
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $CustomerKey;
    /**
     * The AirlinePersonKey
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $AirlinePersonKey;
    /**
     * The ChargeKey
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ChargeKey;
    /**
     * The Comment
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Comment;
    /**
     * Constructor method for SpecialServiceToCancel
     * @uses SpecialServiceToCancel::setAirlineKey()
     * @uses SpecialServiceToCancel::setLogicalFlightKey()
     * @uses SpecialServiceToCancel::setPhysicalFlightKey()
     * @uses SpecialServiceToCancel::setCustomerKey()
     * @uses SpecialServiceToCancel::setAirlinePersonKey()
     * @uses SpecialServiceToCancel::setChargeKey()
     * @uses SpecialServiceToCancel::setComment()
     * @param string $airlineKey
     * @param string $logicalFlightKey
     * @param string $physicalFlightKey
     * @param string $customerKey
     * @param string $airlinePersonKey
     * @param string $chargeKey
     * @param string $comment
     */
    public function __construct($airlineKey = null, $logicalFlightKey = null, $physicalFlightKey = null, $customerKey = null, $airlinePersonKey = null, $chargeKey = null, $comment = null)
    {
        $this
            ->setAirlineKey($airlineKey)
            ->setLogicalFlightKey($logicalFlightKey)
            ->setPhysicalFlightKey($physicalFlightKey)
            ->setCustomerKey($customerKey)
            ->setAirlinePersonKey($airlinePersonKey)
            ->setChargeKey($chargeKey)
            ->setComment($comment);
    }
    /**
     * Get AirlineKey value
     * @return string|null
     */
    public function getAirlineKey()
    {
        return $this->AirlineKey;
    }
    /**
     * Set AirlineKey value
     * @param string $airlineKey
     * @return \StructType\SpecialServiceToCancel
     */
    public function setAirlineKey($airlineKey = null)
    {
        // validation for constraint: string
        if (!is_null($airlineKey) && !is_string($airlineKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($airlineKey, true), gettype($airlineKey)), __LINE__);
        }
        $this->AirlineKey = $airlineKey;
        return $this;
    }
    /**
     * Get LogicalFlightKey value
     * @return string|null
     */
    public function getLogicalFlightKey()
    {
        return $this->LogicalFlightKey;
    }
    /**
     * Set LogicalFlightKey value
     * @param string $logicalFlightKey
     * @return \StructType\SpecialServiceToCancel
     */
    public function setLogicalFlightKey($logicalFlightKey = null)
    {
        // validation for constraint: string
        if (!is_null($logicalFlightKey) && !is_string($logicalFlightKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($logicalFlightKey, true), gettype($logicalFlightKey)), __LINE__);
        }
        $this->LogicalFlightKey = $logicalFlightKey;
        return $this;
    }
    /**
     * Get PhysicalFlightKey value
     * @return string|null
     */
    public function getPhysicalFlightKey()
    {
        return $this->PhysicalFlightKey;
    }
    /**
     * Set PhysicalFlightKey value
     * @param string $physicalFlightKey
     * @return \StructType\SpecialServiceToCancel
     */
    public function setPhysicalFlightKey($physicalFlightKey = null)
    {
        // validation for constraint: string
        if (!is_null($physicalFlightKey) && !is_string($physicalFlightKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($physicalFlightKey, true), gettype($physicalFlightKey)), __LINE__);
        }
        $this->PhysicalFlightKey = $physicalFlightKey;
        return $this;
    }
    /**
     * Get CustomerKey value
     * @return string|null
     */
    public function getCustomerKey()
    {
        return $this->CustomerKey;
    }
    /**
     * Set CustomerKey value
     * @param string $customerKey
     * @return \StructType\SpecialServiceToCancel
     */
    public function setCustomerKey($customerKey = null)
    {
        // validation for constraint: string
        if (!is_null($customerKey) && !is_string($customerKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerKey, true), gettype($customerKey)), __LINE__);
        }
        $this->CustomerKey = $customerKey;
        return $this;
    }
    /**
     * Get AirlinePersonKey value
     * @return string|null
     */
    public function getAirlinePersonKey()
    {
        return $this->AirlinePersonKey;
    }
    /**
     * Set AirlinePersonKey value
     * @param string $airlinePersonKey
     * @return \StructType\SpecialServiceToCancel
     */
    public function setAirlinePersonKey($airlinePersonKey = null)
    {
        // validation for constraint: string
        if (!is_null($airlinePersonKey) && !is_string($airlinePersonKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($airlinePersonKey, true), gettype($airlinePersonKey)), __LINE__);
        }
        $this->AirlinePersonKey = $airlinePersonKey;
        return $this;
    }
    /**
     * Get ChargeKey value
     * @return string|null
     */
    public function getChargeKey()
    {
        return $this->ChargeKey;
    }
    /**
     * Set ChargeKey value
     * @param string $chargeKey
     * @return \StructType\SpecialServiceToCancel
     */
    public function setChargeKey($chargeKey = null)
    {
        // validation for constraint: string
        if (!is_null($chargeKey) && !is_string($chargeKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($chargeKey, true), gettype($chargeKey)), __LINE__);
        }
        $this->ChargeKey = $chargeKey;
        return $this;
    }
    /**
     * Get Comment value
     * @return string|null
     */
    public function getComment()
    {
        return $this->Comment;
    }
    /**
     * Set Comment value
     * @param string $comment
     * @return \StructType\SpecialServiceToCancel
     */
    public function setComment($comment = null)
    {
        // validation for constraint: string
        if (!is_null($comment) && !is_string($comment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comment, true), gettype($comment)), __LINE__);
        }
        $this->Comment = $comment;
        return $this;
    }
}
