<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ViewApisInfo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ViewApisInfo
 * @subpackage Structs
 */
class ViewApisInfo extends AbstractStructBase
{
    /**
     * The ApisInfos
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfApisInformation
     */
    public $ApisInfos;
    /**
     * The Exceptions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ExceptionInformation_Exceptions
     */
    public $Exceptions;
    /**
     * Constructor method for ViewApisInfo
     * @uses ViewApisInfo::setApisInfos()
     * @uses ViewApisInfo::setExceptions()
     * @param \ArrayType\ArrayOfApisInformation $apisInfos
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     */
    public function __construct(\ArrayType\ArrayOfApisInformation $apisInfos = null, \StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this
            ->setApisInfos($apisInfos)
            ->setExceptions($exceptions);
    }
    /**
     * Get ApisInfos value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfApisInformation|null
     */
    public function getApisInfos()
    {
        return isset($this->ApisInfos) ? $this->ApisInfos : null;
    }
    /**
     * Set ApisInfos value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfApisInformation $apisInfos
     * @return \StructType\ViewApisInfo
     */
    public function setApisInfos(\ArrayType\ArrayOfApisInformation $apisInfos = null)
    {
        if (is_null($apisInfos) || (is_array($apisInfos) && empty($apisInfos))) {
            unset($this->ApisInfos);
        } else {
            $this->ApisInfos = $apisInfos;
        }
        return $this;
    }
    /**
     * Get Exceptions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ExceptionInformation_Exceptions|null
     */
    public function getExceptions()
    {
        return isset($this->Exceptions) ? $this->Exceptions : null;
    }
    /**
     * Set Exceptions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     * @return \StructType\ViewApisInfo
     */
    public function setExceptions(\StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        if (is_null($exceptions) || (is_array($exceptions) && empty($exceptions))) {
            unset($this->Exceptions);
        } else {
            $this->Exceptions = $exceptions;
        }
        return $this;
    }
}
